import java.util.*;

//********************************************************************
//  PriorityQueue.java      Author: Ryo (Rio) Akasaka
//  
//  Last modified: Mon April 2, 2007
//
//  Description: Uses Linked Lists to create a Priority Queue with
//  constructor, add, remove, size, and element methods necessary
//  to run the Huffman file compression algorithm.
//********************************************************************

public class PriorityQueue<AnyType> 
{
  private LinkedList<AnyType> ll;
  
  /**
   * Constructor. Prints method by which priority queue is made.
   */
  public PriorityQueue() 
  {
    ll = new LinkedList();
    System.out.println("Using leo's Linked List priority queue.");
  }
  
  /**
   * Add method. Compares object to add
   * and values in linked list and adds
   * so that smallest value is first.
   * @param AnyType x
   * @return true
   */
  public boolean add( AnyType x)
  {
    int i;
    for(i=0; i<ll.size(); i++)  
      { 
	if ((((Comparable) ll.get(i)).compareTo(x)) > 0)
	  {
	    if (i == 0) ll.addFirst(x);
	    else ll.add(i, x); 
	    break;		
	  }
      }
    if (i == ll.size()) ll.addLast(x); 
    
    return true;
  }
  
  /**
   * Size method. 
   * @return size of linked list.
   */  
  public int size()
  { 
    return ll.size();
  }
  
  /**
   * Element method.
   * @return smallest (first) element of linked list.
   * @throw NoSuchElementException if empty.
   */  
  public AnyType element()
  {
    if(ll.size() == 0)
      throw new NoSuchElementException();
    return ll.getFirst();
  }
  
  /**
   * Removes first (smallest) element
   * and returns it.
   * @return first element of linked list.
   * @throw NoSuchElementException if empty.
   */    
  public AnyType remove()
  {
    if(ll.size() == 0)
      throw new NoSuchElementException();
    AnyType object = ll.removeFirst();
    return object;
  }
}
